#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <..\mod5282\system\sim5282.h>



extern "C" { 
void UserMain(void * pd);
extern const unsigned long CPU_CLOCK;
}

const char * AppName="bare_serial";



void OpenBareSerial(int port, unsigned long baud)
{

volatile uartstruct *ThisUart = &sim.uarts[port];

unsigned char ub1 = 0;
unsigned char ub2 = 0x41;

/* Calculate baud rate */
DWORD hdiv = ( ( ( CPU_CLOCK / 16 ) / baud ) + 1 ) >> 1;
ub1 = ( hdiv >> 8 ) & 0xFF;
ub2 = ( hdiv & 0xFF );

ThisUart->ucr = 0x2a; /*Reset Rx Transmit disable Rx disable */
ThisUart->ucr = 0x3a;    /*Reset Tx Transmit disable Rx disable */
ThisUart->ucr = 0x1a;/*Transmit disable Rx disable reset mode reg */

ThisUart->ucr = 0x10;
ThisUart->umr = 0x13; /* umr1 8 data bits no parity */
ThisUart->umr = 0x27;  /* umr2 1 stop*/ 

ThisUart->usr = 0xDD; /* Use the internal timer for Baud Rate Generation */
ThisUart->iacr = 0x00; 
ThisUart->ir = 0x00;  /*Enable No interrupts */

ThisUart->dur = ub1; /* Actualy set the baud rate we calculated */
ThisUart->dlr = ub2;


switch (port) /* Set up the hardware ports */
{
case 0:
	sim.gpio.puapar |= 0x03; /* 0000 0011 UM 26.3.2.15*/
    break;
case 1:
	sim.gpio.puapar |= 0x0C; /*0000 1100 UM 26.3.2.15*/
	break;
case 2:
	{
	 WORD paspar = sim.gpio.paspar;
	 if ( ( paspar & 3 ) == 2 )
	 {
		 paspar &= 0xFFFC;
	 }
	 if ( ( paspar & 6 ) == 4 )
	 {
		 paspar &= 0xFFF3;
	 }
	 /* Third serial on CAN pins */
	 paspar &= 0xF0F; /* 0000 0000 1010 0000  UM 26.3.2.10*/ 
	 paspar |= 0xA0; /* 0000 0000 1010 0000  UM 26.3.2.10*/ 
     sim.gpio.paspar = paspar;
    }
	break;
}//End of switch


ThisUart->ucr = 0x05;/*Enable Tx and Rx */ 
}


void NoIsrWriteChar(int port, char c)
{
 while ( ( sim.uarts[port].usr & 4 ) == 0 ); 
 sim.uarts[port].udb = ( unsigned char ) c;  
}


char NoIsrGetChar(int port)
{
while ( ( sim.uarts[port].usr & 1 ) == 0 );
return sim.uarts[port].udb;
}


int NoIsrCharAvail(int port)
{
   return  ( ( sim.uarts[port].usr & 1 ) != 0 );
}








void UserMain(void * pd)
{
   InitializeStack();
   if (EthernetIP == 0) GetDHCPAddress(); 
   OSChangePrio(MAIN_PRIO);
   EnableAutoUpdate();

   OpenBareSerial(1,115200);

   iprintf("Application started\n");
   while (1)
  {
	   char c=NoIsrGetChar(1);
	   NoIsrWriteChar(1,c);

  }
}
